(function(){
	
	var UserPane = Class.create({
		initialize: function(){
			this.testGetUserInfo();
			this.testHasUserLogin();
			this.testRegister();
			this.testIsGuest();
		},
		
		testGetUserInfo: function(){
			$('getUserInfo').observe('click', function(){
				wifikey.getUserInfo({
					success: function(user){
						alert('getUser success: '+Object.toJSON(user));
					},
					error: function(msg){
						alert('getUser error: '+Object.toJSON(msg));
					},
					cancel: function(){
						alert('getUser cancel');
					}
				});
				
			});
		},
		
		testHasUserLogin: function(){
			$('hasUserLogin').observe('click', function(){
				wifikey.hasUserLogin({
					success: function(result){
						if(result) alert('result='+result+":已登录");
						else alert('result='+result+":未登录");
					}
				});
			});
		},
		
		testRegister: function(){
			$('register').observe('click', function(){
				wifikey.register({
					success: function(user){
						alert('register success: '+Object.toJSON(user));
					},
					error: function(msg){
						alert('register error: '+Object.toJSON(msg));
					}
				});
			});
		},
		
		testIsGuest: function(){
			$('isGuest').observe('click', function(){
				wifikey.hasUserLogin({
					success: function(result){
						alert('result='+result);
					}
				});
			});
		}
	});
	
	var DevicePane = Class.create({
		initialize: function(){
			this.testGetDeviceInfo();
			this.testGetDeviceBasicInfo();
			this.testGetNetworkStatus();
		},
		
		testGetDeviceInfo: function(){
			$('getDeviceInfo').observe('click', function(){
				wifikey.getDeviceInfo({
					success: function(info){
						alert('getDeviceInfo success: '+Object.toJSON(info));
					}
				});
			});
		},

        testGetDeviceBasicInfo: function(){
            $('getDeviceBasicInfo').observe('click', function(){
                wifikey.getDeviceBasicInfo({
                    success: function(info){
                        alert('getDeviceBasicInfo success: '+Object.toJSON(info));
                    }
                });
            });
        },

		testGetNetworkStatus: function(){
			$('getNetworkStatus').observe('click', function(){
				wifikey.getNetworkStatus({
					success: function(result){
						alert('getNetworkStatus success:'+Object.toJSON(result));
					}
				});
			});
		}
	});
	
	var SharePane = Class.create({
		initialize: function(){
			this.testShareInfo();
			this.testIsWXSupported();
		},
		
		testShareInfo: function(){
			$('shareInfo').observe('click', function(){
				wifikey.shareInfo({
					target: 'weixin',
					type: '2',
					title: 'test share',
					content: 'test share content',
					image: null,
					url: null,
					success: function(){
						//alert('分享成功');
					},
					error: function(){
						alert('分享失败');
					},
					cancel: function(){
						alert('取消分享');
					}
				});
			});
		},
		
		testIsWXSupported: function(){
			$('isWXSupported').observe('click', function(){
				wifikey.isWXSupported({
					success: function(result){
						alert('result: '+result);
					}
				});
			});
		}
	});
	
	
	var downloadId = 0;
	var AppStorePane = Class.create({
		
		initialize: function(){
			this.testIsAppInstalled();
			this.testOpenAppStore();
			this.testOpenAppDetail();
			this.testReadAppStatus();
			this.testDownloadApp();
			this.testPauseDownload();
			this.testResumeDownload();
			this.testInstallApp();
			this.testOpenApp();
			this.testRemoveDownload();
		},
		
		testIsAppInstalled: function(){
			$('isAppInstalled').observe('click', function(){
				wifikey.isAppInstalled({
					packageName: 'com.snda.wifilocating.webox',
					success: function(result){
						if(result) alert('已安装');
						else alert('未安装');
					}
				});
			});
		},
		
		testOpenAppStore: function(){
			$('openAppStore').observe('click', function(){
				wifikey.openAppStore();
			});
		},
		
		testOpenAppDetail: function(){
			$('openAppDetail').observe('click', function(){
				wifikey.openAppDetail({
					'storeId': 'store-01',
					'title': 'wifi万能钥匙',
					'readableId': 1234,
				    'pageIndex': 2,
				    'position': 20,
				    'dPos': 1,
				    'appHid': 'akjdfha',
				    'icon': 'fjfjf',
				    'packageName': 'com.bank9f.weilicai',
				});
			});
		},
		
		testReadAppStatus: function(){
			$('readAppStatus').observe('click', function(){
				wifikey.readAppStatus({
					apps: [
				         {
				             'packageName': 'com.bank9f.weilicai',
				             'hid': 'akjdfha'
				         },
				         {
				             'packageName': 'com.lianwifi.wnys',
				             'hid': 631
				         }
				     ],
					success: function(result){
						alert('readAppStatus success:'+Object.toJSON(result));
					},
					error: function(result){
						alert('readAppStatus error:'+Object.toJSON(result));
					}
				});
			});
		},
		
		testDownloadApp: function(){
			$('downloadApp').observe('click', function(){
				var r = confirm("是否自动安装！");
				var ai = r ? 1 : 0;
				wifikey.downloadApp({
					'storeId': 'store-01',
					'title': 'wifi万能钥匙',
					'readableId': 1234,
				    'pageIndex': 2,
				    'position': 20,
				    'dPos': 1,
				    'appHid': 'akjdfha',
				    'icon': 'fjfjf',
				    'packageName': 'com.bank9f.weilicai',
				    'tab': '3',
				    'apkURL': 'https://play.google.com/store/apps/details?id=com.halo.wifikey.wifilocating',
				    'completedURL': 'http://abc.def.com/apk123',
				    'installedURL': 'http://abc.def.com/apk456',
				    'autoInstall': ai,
				    'success': function(result){
						downloadId = JSON.stringify(result);
						alert('downloadId : ' + JSON.stringify(result));
					}
				});
			});
		},
		
		testPauseDownload: function(){
			$('pauseDownload').observe('click', function(){
				wifikey.pauseDownload({
					packageName: 'com.bank9f.weilicai',
				    appHid: 'akjdfha'
				});
			});
		},
		
		testResumeDownload: function(){
			$('resumeDownload').observe('click', function(){
				wifikey.resumeDownload({
					packageName: 'com.bank9f.weilicai',
				    appHid: 'akjdfha'
				});
			});
		},
		
		testInstallApp: function(){
			$('installApp').observe('click', function(){
				wifikey.installApp({
					packageName: 'com.bank9f.weilicai',
				    appHid: 'akjdfha'
				});
			});
		},
		
		testOpenApp: function(){
			$('openApp').observe('click', function(){
				wifikey.openApp({
					packageName: 'com.bank9f.weilicai',
				    appHid: 'akjdfha'
				});
			});
		},
		
		testRemoveDownload: function(){
			$('removeDownload').observe('click', function(){
				var r = confirm("根据DownloadID删除？");
				if (r) {
					wifikey.removeDownload({"downloadId":downloadId});
				} else {
					r=confirm("根据HID删除？");
					if (r) {
						wifikey.removeDownload({'appHid': 'akjdfha'});
					} else {
						wifikey.removeDownload({'apkURL': 'https://play.google.com/store/apps/details?id=com.halo.wifikey.wifilocating'});
					}
				}
			});
		}
	});
	
	
	var BrowserPane = Class.create({
		
		initialize: function(){
			this.testBrowserOpen();
			this.testBrowserClose();
			this.testCloseBannerAd();
			this.testForward();
			this.testBackward();
			this.testShowOptionMenu();
			this.testHideOptionMenu();
			this.testShowActionBar();
			this.testHideActionBar();
		},
		
		testBrowserOpen: function(){
			$('openBrowser').observe('click', function(){
				wifikey.openBrowser({
					url: 'http://m.baidu.com'
				});
			}.bind(this));
		},
		
		testBrowserClose: function(){
			$('closeBrowser').observe('click', function(){
				wifikey.closeBrowser();
			}.bind(this));
		},
		
		testCloseBannerAd: function(){
			$('closeBannerAd').observe('click', function(){
				wifikey.closeBannerAd();
			}.bind(this));
		},
		
		testForward: function(){
			$('forward').observe('click', function(){
				wifikey.forward({
					step: 2
				});
			}.bind(this));
		},
		
		testBackward: function(){
			$('backward').observe('click', function(){
				wifikey.backward({
					step: 3
				});
			}.bind(this));
		},
		
		testShowOptionMenu: function(){
			$('showOptionMenu').observe('click', function(){
				wifikey.showOptionMenu();
			}.bind(this));
		},
		
		testHideOptionMenu: function(){
			$('hideOptionMenu').observe('click', function(){
				wifikey.hideOptionMenu();
			}.bind(this));
		},

        testShowActionBar: function(){
            $('showActionBar').observe('click', function(){
                wifikey.showActionBar();
            }.bind(this));
        },

        testHideActionBar: function(){
            $('hideActionBar').observe('click', function(){
                wifikey.hideActionBar();
            }.bind(this));
        }
	});
	
	var EventPane = Class.create({
			
			initialize: function(){
				this.testAddEventListener();
				this.testRemoveEventListener();
				this.testDispatchEvent();
			},
			
			testDispatchEvent: function(){
				$('dispatchEvent').observe('click', function(){
					wifikey.dispatchEvent({
						type: 'testType',
						data: 'testData'
					});
				}.bind(this));
			},
			
			testAddEventListener: function(){
				$('addEvent').observe('click', function(){
					if(this.handlerId) wifikey.removeEventListener({
						id: this.handlerId
					});
					this.handlerId = wifikey.addEventListener({
						type: 'appChange',
						listener: this.onEvent.bind(this)
					});
				}.bind(this));
			},
			
			testRemoveEventListener: function(){
				$('rmEvent').observe('click', function(){
					wifikey.removeEventListener({
						id: this.handlerId
					});
					$('eventLabel').update('');
				}.bind(this));
			},
			
			onEvent: function(event){
				$('eventLabel').update(Object.toJSON(event));
			}
	});
	
	
	var OthersPane = Class.create({
		initialize: function(){
			this.testGetLocation();
			this.testScanBarcode();
			this.testOrder();
			this.testSendSMS();
			this.testGetWifiNodes();
			this.testTrace();
			this.testGetJsApiVersion();
			this.testSetShareData();
			this.testGetShareData();
			this.testStartComponent();
			this.testAppointmentDownload();
			this.testCreateShortCut();
			this.testCreateShortCut2();
			this.testFetchInfo();
			this.testSignParams();
			this.testSignCustomParams();
			this.testCheckJsApi();
			this.testActivateApp();
			this.testGetAppStatus();
		},		
		
		testGetJsApiVersion: function(){
			$('getJsApiVersion').observe('click', function(){
				alert('js api version: '+wifikey.getJsApiVersion());				
			});
		},
		
		testGetLocation: function(){
			$('getLocation').observe('click', function(){
				wifikey.getLocation({
					success: function(location){
						alert('getLocation success: '+Object.toJSON(location));
					},
					error: function(msg){
						alert('getLocation error: '+Object.toJSON(msg));
					},
					cancel: function(){
						alert('getLocation cancel');
					}
				});
				
			});
		},
		
		testScanBarcode: function(){
			$('scanBarcode').observe('click', function(){
				wifikey.scanBarcode({
					success: function(result){
						alert('scanBarCode success:'+result);
					},
					cancel: function(){
						alert('scanBarCode cancel')
					}
				});
			});
		},
		
		testOrder: function(){
			$('order').observe('click', function(){
				wifikey.order({
					success: function(result){
						alert('order success: '+Object.toJSON(result));
					},
					error: function(error){
						alert('order error: '+Object.toJSON(error));
					},
					cancel: function(){
						alert('error cancel');
					}
				});
			});
		}, 
		
		testShowApp: function(){
			$('showApp').observe('click', function(){
				wifikey.showApp({
					packageName: 'com.snda.wifilocating.webox',
					market:'google play store'
				});
			});
		},
		
		testSendSMS: function(){
			$('sendSMS').observe('click', function(){
				wifikey.sendSMS({
					phoNum: '1234567890',
					msg: 'just for test',					
					success: function(result){
						//alert('sendSMS success');
					},					
					error: function(error){
						alert('sendSMS error'+Object.toJSON(error));
					}
				});
			});
		},
		
		testGetWifiNodes: function(){
			$('getWifiNodes').observe('click', function(){
				wifikey.getWifiNodes({
					success: function(result){
						alert('getWifiNodes success:'+Object.toJSON(result));
					}
				});
			});
		},
		
		testTrace: function(){
			$('trace').observe('click', function(){
				wifikey.trace({
					type: 'abc',
					data: 'test trace data'
				});
			}.bind(this));
		},
		
		testSetShareData: function(){
			$('setShareData').observe('click', function(){
				wifikey.setShareData({
					key1: 'abc',
					key2: 'test trace data'
				});
			}.bind(this));
		},
		
		testGetShareData: function(){
			$('getShareData').observe('click', function(){
				var value = wifikey.getShareData('key1');
				alert('data = '+value);
			}.bind(this));
		},
		
		testFetchInfo: function(){
			$('fetchInfo').observe('click', function(){
				wifikey.fetchInfo({
					data:'[{"key":"ci","method":"getcltInfo","params":[null]},{"key":"vc","method":"getcltInfo","params":["vcode"]},{"key":"lalo","method":"getLaLo","params":[]}]',
					success: function(msg){
						alert(msg);
					}
				});
			}.bind(this));
		},
		
		testSignParams: function(){
			$('signParams').observe('click', function(){
				wifikey.signParams({
					a:'b1',
					c:'d1',
					success: function(msg){
						alert(msg);
					}
				});
			}.bind(this));
		},
		
		testSignCustomParams: function(){
			$('signCustomParams').observe('click', function(){
				wifikey.signCustomParams({
					a:'b',
					c:'d',
					success: function(msg){
						alert(msg);
					}
				});
			}.bind(this));
		},
		
		testAppointmentDownload: function(){
			$('appointmentDownload').observe('click', function(){
				wifikey.appointmentDownload({
					url: "",
					icon: "",
					name: "",
					onlyWifi: ""
				});
			}.bind(this));
		},
		
		testStartComponent: function(){
			$('startComponent').observe('click', function(){
				wifikey.startComponent({
					action: "wifi.intent.action.SPEED_MAIN",
					className: "class_name1",
					ext: "test1",
					type: 0,
					startactivityforresult: true,
					callback: "alert"
				});
			}.bind(this));
		},

		testCheckJsApi: function(){
			$('checkJsApi').observe('click', function(){
				wifikey.checkJsApi({
					jsApiList: ['chooseImage','showOptionMenu'],
                    success: function(res) {
                    	alert(res);
                    }
				});
			}.bind(this));
		},

        testActivateApp: function(){
            $('activateApp').observe('click', function(){
                wifikey.activateApp({
                    appHid: 'zhangxin01234',
                    url: "http://download.youni.im/zhangxin_release.apk",
                    pkg: "com.zenmen.palmchat",
                    quiet: 0,
                    md5: "04DC7D474A773404074616E2A283FC87"
                });
            }.bind(this));
        },

        testGetAppStatus: function(){
            $('getAppStatus').observe('click', function(){
                wifikey.getAppStatus({
                    appList: [{
                        appHid: 'zhangxin01234',
                        pkg: 'com.zenmen.palmchat'
                    }],
                    success: function(res) {
                        alert(res);
                    }
                });
            }.bind(this));
        }
	});
	
	var Beartbeat = Class.create({
		initialize: function(){
			setInterval(function(){
				console.log('Beartbeat : '+new Date().getTime());
			}, 3000);
		}
	});
	
	document.observe('dom:loaded', function(){
		console.log('init wifikey sdk');
		//ijimu.Touch.disableDrag = true;
		wifikey.init({
			success: function(){
				//alert('init wifikey sdk success');
				new UserPane();
				new DevicePane();
				new SharePane();
				new AppStorePane();
				new EventPane();
				new BrowserPane();
				new OthersPane();
			}.bind(this),
			error: function(msg){
				alert('init wifikey sdk error : '+msg);
			},
			auth: function(msg){
				alert('return data ' + msg);
			},
			appId: 'A0008',
			timestamp: '1100110011001010',
			sign: '5DC54E1FDF586B2B9A33E2E4897F70DF'
		});
		//new Beartbeat();
	});
})();
	