(function() {
    try {
        var time = performance.timing;
        var timingObj = {};

        var loadTime = (time.loadEventEnd - time.loadEventStart) / 1000;
        if(loadTime < 0) {return;}

        timingObj['重定向时间'] = (time.redirectEnd - time.redirectStart) / 1000;
        timingObj['DNS解析时间'] = (time.domainLookupEnd - time.domainLookupStart) / 1000;
        timingObj['TCP完成握手时间'] = (time.connectEnd - time.connectStart) / 1000;
        timingObj['HTTP请求响应完成时间'] = (time.responseEnd - time.requestStart) / 1000;
        timingObj['DOM开始加载前所花费时间'] = (time.responseEnd - time.navigationStart) / 1000;
        timingObj['DOM加载完成时间'] = (time.domComplete - time.domLoading) / 1000;
        timingObj['DOM结构解析完成时间'] = (time.domInteractive - time.domLoading) / 1000;
        timingObj['脚本加载时间'] = (time.domContentLoadedEventEnd - time.domContentLoadedEventStart) / 1000;
        timingObj['onload事件时间'] = (time.loadEventEnd - time.loadEventStart) / 1000;
        timingObj['页面完全加载时间'] = (timingObj['重定向时间'] + timingObj['DNS解析时间'] + timingObj['TCP完成握手时间'] + timingObj['HTTP请求响应完成时间'] + timingObj['DOM结构解析完成时间'] + timingObj['DOM加载完成时间']);

        console.log("--------------------主页面: "+window.location.href+" -----------------------");
        for(item in timingObj) {
            console.log(item + ":" + timingObj[item] + '秒(s)');
        }

        var subResArray = performance.getEntries();
        console.log('网页子资源数量：'+subResArray.length);
        for (var i = 0; i < subResArray.length; i++) {
            var subResItem = subResArray[i];
            var subResInfo = {};

            subResInfo['资源编号'] = i;
            subResInfo['资源名'] = subResItem.name;
            subResInfo['资源类型'] = subResItem.entryType;
            subResInfo['重定向时间'] = (subResItem.redirectEnd - subResItem.redirectStart) / 1000 + " 秒(s)";
            subResInfo['DNS解析时间'] = (subResItem.domainLookupEnd - subResItem.domainLookupStart) / 1000 + " 秒(s)";
            subResInfo['TCP完成握手时间'] = (subResItem.connectEnd - subResItem.connectStart) / 1000 + " 秒(s)";
            subResInfo['HTTP请求响应完成时间'] = (subResItem.responseEnd - subResItem.requestStart) / 1000 + " 秒(s)";
            console.log("-------------------------------------------");
            for (item in subResInfo) {
                console.log(item + ": " +subResInfo[item]);
            }
        }

    } catch(e) {
    }
})();